{ TemperatureApp.p -- application-level functions }
{ Created 10/30/98 12:58 PM by AppMaker }

Unit TemperatureApp;
Interface

Uses
	Types,
	Quickdraw,
	Controls,
	Events,
	Files,
	Lists,
	Menus,
	TextEdit,
	AMDoc,
	AMApp;

type
	TemperatureApp		= object (AMApp)

	{data members}

	{methods - public}
		Procedure Initialize; Override;
		Procedure OpenApp; Override;

		Function  DoCommand		(inCommand:	longint): Boolean; Override;

	{methods - internal}
		Function  MakeDoc: AMDoc; Override;

	end;

{----------}
Function NewTemperatureApp: TemperatureApp;

{----------}
Implementation

Uses
	ResourceDefs,

	TemperatureEngine,
	TemperatureDoc,
	AMWindow;

{----------}
Function NewTemperatureApp: TemperatureApp;
var
	app:		TemperatureApp;
begin
	New (app);
	if app <> nil then begin
		app.Initialize;
	end;
	NewTemperatureApp := app;
end;

{----------}
Procedure TemperatureApp.Initialize;
Begin
	inherited Initialize;

	mNumOpenTypes := 1;
	mOpenTypeList [0] := kFileType;
End;

{----------}
Function TemperatureApp.MakeDoc: AMDoc;
var
	aDoc:		TemperatureDoc;
Begin
	aDoc := NewTemperatureDoc;

	if aDoc <> nil then begin
		{? add to list of docs}
	end;

	MakeDoc := aDoc;
End;

{----------}
Procedure TemperatureApp.OpenApp;
Begin
	DoNew;
End;

{----------}
Function TemperatureApp.DoCommand (
	inCommand:		longint): Boolean;
begin
	DoCommand := true;
	case inCommand of
		cmdNew:
				DoNew;
		cmdOpen:
				DoOpen;
		cmdClose:
				DoClose;
		cmdQuit:
				DoQuit;

		otherwise
				DoCommand := false;
	end; {case}
end;

end.
