{ TemperatureEngine.p -- application-specific data management }
{ Created 10/30/98 12:58 PM by AppMaker }

{ This module contains data structures to access the data in your }
{ document's file(s). The purpose is to isolate the details of the }
{ data representation into this module and to provide accessor }
{ functions for reading/writing logical pieces of the data. }
{ For your application, you will probably rewrite most of this. }
{ This module will not be regenerated by AppMaker unless you delete it. }

Unit TemperatureEngine;
Interface

Uses
	Types,
	Quickdraw,
	Controls,
	Events,
	Files,
	Lists,
	Menus,
	DDocData,
	TextEdit,
	AMEngine;

const
	kSignature		= 'XXXX';
	kFileType		= 'TEXT';

type
	TemperatureEngine		= object (AMEngine)

	{data members}

	{methods - public}
		Procedure Initialize; Override;

		Function  GetDocData: DDocData;

	{methods - internal}
		Procedure InitData; Override;
		Procedure DisposeData; Override;
		Procedure ReadFile; Override;
		Procedure WriteFile; Override;
	end;

{----------}
Function NewTemperatureEngine: TemperatureEngine;

{----------}
Implementation

Uses
	Globals,
	Miscellany;

{----------}
Function NewTemperatureEngine: TemperatureEngine;
var
	engine:		TemperatureEngine;
begin
	New (engine);
	if engine <> nil then begin
		engine.Initialize;
	end;
	NewTemperatureEngine := engine;
end;

{----------}
Procedure TemperatureEngine.Initialize;
begin
	inherited Initialize;

	mFileType := kFiletype;
	mSignature := kSignature;
end;

{ These are just models for your own data access functions. }
{ Replace them with ones that do something useful. }

{----------}
Function TemperatureEngine.GetDocData: DDocData;
begin
	GetDocData := NewDDocData;
end;


{----------}
Procedure TemperatureEngine.InitData;
begin
	{override to initialize your data structures}
end;

{----------}
Procedure TemperatureEngine.DisposeData;
begin
	{override to dispose your data structures}
end;

{----------}
Procedure TemperatureEngine.ReadFile;
begin
	InitData;
	mDirty := false;
	{override to read from the current file into your data structures}
end;

{----------}
Procedure TemperatureEngine.WriteFile;
begin
	mDirty := false;
	{override to write your data structures to the current file}
end;

end.
